/*-
 * ~~~~~~licensing~~~~~~
 * object-producer-core
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.objectmodel;

import java.util.HashMap;
import java.util.Map;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.google.gson.JsonObject;

import ru.entaxy.platform.base.objects.EntaxyObject.FIELDS;

public class FactoredObjectProxy extends FactoredObject {

	private static final Logger log = LoggerFactory.getLogger(FactoredObjectProxy.class);
	
	public static final String IS_PROXY_FIELD = "isProxy";
	
	public static final String UNKNOWN_PROXIED_FACTORY_ID = "__##";

	public static JsonObject getDefaultOrigin() {
		JsonObject result = new JsonObject();
		result.addProperty(FIELDS.FACTORY_ID, UNKNOWN_PROXIED_FACTORY_ID);
		result.addProperty(IS_PROXY_FIELD, true);
		return result;
	}
	
	public static boolean isProxy(JsonObject jsonObject) {
		try {
			
			if (!jsonObject.has(IS_PROXY_FIELD))
				return false;
			boolean isRef = jsonObject.get(IS_PROXY_FIELD).getAsBoolean();
			return isRef;
		} catch (Exception e) {
			return false;
		}
		
	}
	
	public FactoredObjectProxy(ObjectModel objectModel) {
		super(objectModel);
	}

	@Override
	public void wrap(JsonObject object, Map<String, Object> context, String path) {
		super.wrap(object, context, path);
	}
	
}
